##################
# Build CosmoTool
##################

IF (Boost_INTERNAL_INSTALL)
  SET(BOOST_DEF  -DBoost_DIR:STRING=${Boost_INTERNAL_INSTALL} -DBOOST_ROOT:STRING=${Boost_INTERNAL_INSTALL})
ELSE()
  SET(BOOST_DEF)
ENDIF()

  #v1.0.0a7.tar.bz2
ExternalProject_Add(cosmotool
  URL https://bitbucket.org/glavaux/cosmotool/get/59bb99e.tar.gz
  DEPENDS ${cosmotool_DEPS}
  SOURCE_DIR ${COSMOTOOL_DIR}
  PREFIX ${BUILD_PREFIX}/cosmotool-prefix
  CMAKE_CACHE_ARGS
    -DCMAKE_INSTALL_PREFIX:STRING=${EXT_INSTALL}
    -DCMAKE_PREFIX_PATH:STRING=${SPECIAL_PREFIX_PATH}
    -DEIGEN_PATH:STRING=${EIGEN_PATH}
    -DCMAKE_MODULE_PATH:STRING=${EXT_INSTALL}/share/cmake;${CMAKE_MODULE_PATH}
    -DCMAKE_C_COMPILER:STRING=${CMAKE_C_COMPILER}
    -DCMAKE_CXX_COMPILER:STRING=${CMAKE_CXX_COMPILER}
    -DHDF5_DIR:STRING=${HDF5_ROOTDIR}/share/cmake
    -DHDF5_ROOTDIR:STRING=${HDF5_ROOTDIR}
    -DNETCDF_INCLUDE_PATH:STRING=${NETCDF_INCLUDE_PATH}
    -DNETCDFCPP_INCLUDE_PATH:STRING=${NETCDFCPP_INCLUDE_PATH}
    -DGSL_INCLUDE_PATH:STRING=${GSL_INCLUDE}
    -DGSL_LIBRARY:STRING=${GSL_LIBRARY}
    -DGSLCBLAS_LIBRARY:STRING=${GSL_CBLAS_LIBRARY}
    -DINTERNAL_GSL:BOOL=OFF
    -DINTERNAL_EIGEN:BOOL=ON
    -DYORICK_SUPPORT:BOOL=OFF
    -DENABLE_SHARP:BOOL=OFF
    -DBUILD_PYTHON:BOOL=OFF
    -DENABLE_OPENMP:BOOL=${ENABLE_OPENMP}
    -DPKG_CONFIG_USE_CMAKE_PREFIX_PATH:BOOL=ON
    -DBoost_DEBUG:BOOL=ON
    ${BOOST_DEF}
    -DZLIB_LIBRARY:STRING=${ZLIB_LIBRARY}
  BUILD_BYPRODUCTS ${EXT_INSTALL}/lib/libCosmoTool.a
  LIST_SEPARATOR ;
)

SET(COSMOTOOL_LIBRARY ${EXT_INSTALL}/lib/libCosmoTool.a)
set(COSMOTOOL_INCLUDE_PATH ${EXT_INSTALL}/include)

include_directories(${COSMOTOOL_INCLUDE_PATH} )
